SystemOrganization addCategory: #'TyH-TP-Final'!
SystemOrganization addCategory: #'TyH-TP-Final-Test'!
SystemOrganization addCategory: #'TyH-TP-Final-Modelo'!

Object subclass: #Emisor
	instanceVariableNames: 'nombre apellido DNI CUIT direccion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!Emisor class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 21:58'!
crear: unDNI nombre: unNombre apellido: unApellido cuit: unCUIT direccion: unaDireccion

| instancia |

instancia := Emisor new.

instancia setDNI: unDNI.
instancia setNombre: unNombre.
instancia setApellido: unApellido.
instancia setCUIT: unCUIT.
instancia setDireccion: unaDireccion.

^ instancia.


	! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:50'!
getApellido
	^apellido 

! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:51'!
getCUIT
	^CUIT! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:51'!
getDNI
	^DNI! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:51'!
getDireccion
	^direccion ! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:52'!
getNombre
	^nombre ! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:54'!
setApellido: unApellido

	apellido := unApellido.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:54'!
setCUIT: unCUIT

	CUIT := unCUIT.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:55'!
setDNI: unDNI

	DNI :=DNI.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:55'!
setDireccion: unaDireccion

	direccion := unaDireccion.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:55'!
setNombre: unNombre

	nombre := unNombre.! !

Object subclass: #Order
	instanceVariableNames: 'cantidadUnidades fechaIngreso precio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

Order subclass: #OrdenCompra
	instanceVariableNames: 'direccionRecepcion formaEnvio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!OrdenCompra class methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 11:47'!
crear:unaFechaIngreso
cantidad:unaCantidadUnidades
precio:unPrecio
recibirEn:unaDireccionRecepcion
enviarComo: unaFormaEnvio

| instancia |

instancia := OrdenCompra new.

instancia setFechaIngreso: unaFechaIngreso.
instancia setCantidadUnidades: unaCantidadUnidades.
instancia setPrecio: unPrecio.
instancia setDireccionRecepcion: unaDireccionRecepcion.
instancia setFormaEnvio: unaFormaEnvio.

^instancia 
! !

!OrdenCompra methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:29'!
getDireccionRecepcion
 ^direccionRecepcion ! !

!OrdenCompra methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:29'!
getFormaEnvio
 ^formaEnvio ! !

!OrdenCompra methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:30'!
setDireccionRecepcion: unaDireccionRecepcion
  direccionRecepcion  := unaDireccionRecepcion ! !

!OrdenCompra methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:29'!
setFormaEnvio: unaFormaEnvio
 ^formaEnvio := unaFormaEnvio ! !

Order subclass: #OrdenVenta
	instanceVariableNames: 'fechaDisponibilidad medioPago'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!OrdenVenta class methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 11:50'!
crear:unaFechaIngreso
cantidad:unaCantidadUnidades
precio:unPrecio
disponibleEnFecha:unaFechaDisponibilidad
pagoEn: unMedioPago

| instancia |

instancia := OrdenVenta new.

instancia setFechaIngreso: unaFechaIngreso.
instancia setCantidadUnidades: unaCantidadUnidades.
instancia setPrecio: unPrecio.
instancia setFechaDisponibilidad: unaFechaDisponibilidad.
instancia setMedioPago: unMedioPago.

^instancia 
! !

!OrdenVenta methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:31'!
getFechaDisponibilidad
 ^fechaDisponibilidad  ! !

!OrdenVenta methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:31'!
getMedioPago
 ^medioPago ! !

!OrdenVenta methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:31'!
setFechaDisponibilidad: unaFechaDisponibilidad
  fechaDisponibilidad   := unaFechaDisponibilidad ! !

!OrdenVenta methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:32'!
setMedioPago: unMedioPago
  medioPago := unMedioPago ! !

!Order class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:21'!
ask: aQuantity price: aPrice

| instance |

instance := OrdenCompra new.

instance setCantidadUnidades: aQuantity.
instance setPrecio: aPrice.


^ instance.
! !

!Order class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:22'!
ask: aQuantity price: aPrice date: aDate

| instance |

instance := OrdenCompra new.

instance setCantidadUnidades: aQuantity.
instance setPrecio: aPrice.
instance setFechaIngreso: aDate.


^ instance.
! !

!Order class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:21'!
bid: aQuantity price: aPrice

| instance |

instance := OrdenVenta new.

instance setCantidadUnidades: aQuantity.
instance setPrecio: aPrice.


^ instance.
! !

!Order class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:21'!
bid: aQuantity price: aPrice date: aDate

| instance |

instance := OrdenVenta new.

instance setCantidadUnidades: aQuantity.
instance setPrecio: aPrice.
instance setFechaIngreso: aDate.


^ instance.
! !

!Order methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 19:02'!
calcularPrecioUnitario
	^(precio / cantidadUnidades)! !

!Order methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 16:43'!
getCantidadUnidades
    ^cantidadUnidades ! !

!Order methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:54'!
getFechaIngreso

| resultado |

(fechaIngreso isKindOf: Date) ifFalse: [ resultado := (Date readFromString: fechaIngreso) ] 
	 ifTrue: [resultado := fechaIngreso].

^ resultado.

! !

!Order methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:06'!
getPrecio
    ^precio! !

!Order methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:08'!
setCantidadUnidades: unaCantidadUnidades
	cantidadUnidades  := unaCantidadUnidades ! !

!Order methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:08'!
setFechaIngreso: unaFechaIngreso
	fechaIngreso := unaFechaIngreso ! !

!Order methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:09'!
setPrecio: unPrecio
	precio := unPrecio ! !

Object subclass: #OrderBook
	instanceVariableNames: 'ordenesCompra ordenesVenta tickets ocCandidatas ovCandidatas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!OrderBook class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:19'!
new

| instancia | 

instancia := super new.

instancia inicializar.

^instancia.
! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 19:10'!
addOrder: aOrder

(aOrder isKindOf: OrdenVenta) ifTrue: [ordenesVenta add:aOrder].
(aOrder isKindOf: OrdenCompra) ifTrue: [ordenesCompra add:aOrder].! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 19:15'!
ejecutarTrading 


"Ejecuta el proceso de trading"
	
	| precioMercadoCalculado ovTransaccionada ovMatcheadas tradingTicket |

	precioMercadoCalculado := self marketPrice.
	ovCandidatas := self  obtenerOrdenesVentaCandidatas: precioMercadoCalculado.
	ocCandidatas := self obtenerOrdenesCompraCandidatas: precioMercadoCalculado.
	
	"Recorre las OC candidatas y las compara una a una contra las OV con igual cantidad"	
	ocCandidatas do: [:ocTransaccionando | 
					
			ovMatcheadas := ovCandidatas select: [:ov | ov getCantidadUnidades = ocTransaccionando getCantidadUnidades].
			
			(ovMatcheadas size > 0)
 			ifTrue: [ 
				
				"Toma la primera OV con igual cantidad"	
				ovTransaccionada := ovMatcheadas first. 
			
				"Crea el Trading Ticket y remueve las ordenes del orderbook"
				tradingTicket := TradingTicket crear: ocTransaccionando ordenVenta: ovTransaccionada precioMercado: precioMercadoCalculado.			

				self quitarOrdenCompra: ocTransaccionando.
				self quitarOrdenVenta: ovTransaccionada.
				self tradingTickets add: tradingTicket.
				
		  		   ].
			 ].
			! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/8/2012 17:48'!
getCantidadOrdenesRegistradas

^(ordenesCompra size) + (ordenesVenta size).! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 18:15'!
getOrdenesCompra
^ordenesCompra! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:52'!
getOrdenesVenta

^ordenesVenta.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:13'!
inicializar

ordenesCompra := OrderedCollection new.
ordenesVenta := OrderedCollection new.

tickets := OrderedCollection new. 
ocCandidatas := SortedCollection new.
ovCandidatas := SortedCollection new.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 19:15'!
marketPrice

| tabla |

"Calcula del precio del mercado en funcin de las ordenes registradas hasta el momento. 
Para calcular el precio del mercado la clase PEM hace uso de la clase TablaPrecioMercado a quien sabe como calcular este precio".

tabla := TablaPrecioMercado crear.

"1 - Agrega todas las ordenes de compra a la tabla" 

(self getOrdenesCompra) do: [:oc |
	
		tabla agregarDemandaPrecio: oc calcularPrecioUnitario cantidad: oc getCantidadUnidades ].

"2 - Agrega todas las ordenes de venta a la tabla"

(self getOrdenesVenta) do: [:ov |
	
		tabla agregarOfertaPrecio: ov calcularPrecioUnitario cantidad: ov getCantidadUnidades].
" 3 - Obtiene el precio del mercado"
^ tabla calcularPrecioMercado.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/8/2012 17:20'!
obtenerOrdenesCompraCandidatas: unPrecioMercado

| ordenesCompraCantidatasFiltradas ordenesCompraCandidatasOrdenadas | 

"Filtrar las ordenes de compra candidatas, es decir las ordenes de compra con precio > al precio de mercado"
ordenesCompraCantidatasFiltradas := ordenesCompra select: [:unaOrdenCompra | (unaOrdenCompra calcularPrecioUnitario) >= unPrecioMercado].

ordenesCompraCandidatasOrdenadas := ordenesCompraCantidatasFiltradas asSortedCollection: 
     [:unaOrdenCompra :otraOrdenCompra | 
	(unaOrdenCompra calcularPrecioUnitario) > (otraOrdenCompra calcularPrecioUnitario)
	or:
	[ (unaOrdenCompra calcularPrecioUnitario) = (otraOrdenCompra calcularPrecioUnitario) and: [(unaOrdenCompra getFechaIngreso) < (otraOrdenCompra getFechaIngreso)] ]
].	
	

^ ordenesCompraCandidatasOrdenadas  ! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/8/2012 17:24'!
obtenerOrdenesVentaCandidatas: unPrecioMercado

| ordenesVentaCantidatasFiltradas ordenesVentaCandidatasOrdenadas | 

"Filtrar las ordenes de centa candidatas, es decir las ordenes de venta con precio < al precio de mercado"
ordenesVentaCantidatasFiltradas := ordenesVenta  select: [:unaOrdenVenta | (unaOrdenVenta calcularPrecioUnitario) <= unPrecioMercado].

ordenesVentaCandidatasOrdenadas := ordenesVentaCantidatasFiltradas asSortedCollection: 
     [:unaOrdenVenta :otraOrdenVenta | 
	(unaOrdenVenta calcularPrecioUnitario) < (otraOrdenVenta calcularPrecioUnitario)
	or:
	[ (unaOrdenVenta calcularPrecioUnitario) = (otraOrdenVenta calcularPrecioUnitario) and: [(unaOrdenVenta getFechaIngreso) < (otraOrdenVenta getFechaIngreso)] ]
].	
	
^ ordenesVentaCandidatasOrdenadas 
! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:24'!
quitarOrdenCompra: unaOrden

ordenesCompra remove: unaOrden.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:24'!
quitarOrdenVenta: unaOrden

ordenesVenta remove: unaOrden.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:18'!
tradingTickets

^ tickets.! !

Object subclass: #PEM
	instanceVariableNames: 'emisores orderBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!PEM class methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 12:50'!
crear
	"Crea una nueva instancia del PEM con las colecciones incializadas"

	| instancia |

instancia := PEM new.
instancia inicializar.
^instancia.
! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:15'!
addOrder: aOrder

orderBook addOrder: aOrder.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:06'!
agregarEmisor: unEmisor

"Agrega un nuevo emisor al PEM"

	emisores add: unEmisor.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:07'!
agregarTradingTicket: unTicket

"Agrega un nuevo Ticket al PEM"

tickets add: unTicket.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:16'!
ejecutarTrading

orderBook ejecutarTrading.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/8/2012 17:39'!
getCantidadEmisores

^emisores size.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/8/2012 17:49'!
getCantidadOrdenesRegistradas 

^orderBook getCantidadOrdenesRegistradas.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 20:44'!
getEmisores

^emisores.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 18:09'!
getOrderbook
^orderBook ! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:19'!
inicializar

"Inicializa las colecciones del PEM"

emisores := OrderedCollection new.

orderBook := OrderBook new.
! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:17'!
marketPrice 

^ orderBook marketPrice.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:07'!
quitarEmisor: unEmisor

emisores remove: unEmisor.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:18'!
tradingTickets 

^ orderBook tradingTickets.! !

Object subclass: #RegistroTablaPrecioMercado
	instanceVariableNames: 'precio demanda oferta demandaTeorica ofertaTeorica'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!RegistroTablaPrecioMercado class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:51'!
crear: unPrecio

| instancia |

instancia := RegistroTablaPrecioMercado new.
instancia inicializar.
instancia setPrecio: unPrecio.

^instancia.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:28'!
calcularUnidadesTeoricas

| resultado |

resultado := 0.

(demandaTeorica <= ofertaTeorica ) ifFalse: [resultado:= ofertaTeorica]  ifTrue: [resultado := demandaTeorica].

^resultado.
! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
getDemanda

^demanda.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:02'!
getDemandaTeorica

^demandaTeorica.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
getOferta

^oferta.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:03'!
getOfertaTeorica

^ofertaTeorica.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
getPrecio

^precio.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:28'!
inicializar

precio := 0.
demanda := 0.
oferta := 0.
demandaTeorica :=0.
ofertaTeorica :=0.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
setPrecio: unPrecio

precio := unPrecio.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:06'!
sumarDemanda: unaCantidad

demanda := demanda + unaCantidad.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:09'!
sumarDemandaTeorica: unaCantidad


demandaTeorica := demandaTeorica + unaCantidad.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:57'!
sumarOferta: unaCantidad

oferta := oferta + unaCantidad.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:09'!
sumarOfertaTeorica: unaCantidad

ofertaTeorica := ofertaTeorica + unaCantidad.! !

Object subclass: #TablaPrecioMercado
	instanceVariableNames: 'filas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!TablaPrecioMercado class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:52'!
crear

| instancia |

instancia := TablaPrecioMercado new.
instancia inicializar.

^instancia.

! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:52'!
agregarDemandaPrecio: unPrecio cantidad: unaCantidad

| fila |

fila := RegistroTablaPrecioMercado crear:unPrecio.
fila sumarDemanda:  unaCantidad.

(filas includesKey:unPrecio) 
	ifFalse: [filas at:unPrecio put: fila]
	ifTrue: [(filas at:unPrecio) sumarDemanda: unaCantidad].
! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:56'!
agregarOfertaPrecio: unPrecio cantidad: unaCantidad

| fila |

fila := RegistroTablaPrecioMercado crear:unPrecio.
fila sumarOferta: unaCantidad.


(filas includesKey:unPrecio) 
	ifFalse: [filas at:unPrecio put: fila]
	ifTrue: [(filas at:unPrecio) sumarOferta: unaCantidad].
! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:29'!
calcularDemandaTeoricaPorPrecio


filas do: [:fila |
	
	filas do: [:otraFila |
		
		((fila getPrecio) <= (otraFila getPrecio)) ifTrue: [fila sumarDemandaTeorica: (otraFila getDemanda)].
		
		]	
	
	] ! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:31'!
calcularOfertaTeoricaPorPrecio


filas do: [:fila |
	
	filas do: [:otraFila |
		
		((fila getPrecio) >= (otraFila getPrecio)) ifTrue: [fila sumarOfertaTeorica: (otraFila getOferta)].
		
		]	
	
	] ! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:30'!
calcularPrecioMercado

| precioMercado unidadesTeoricas |

precioMercado := 0.
unidadesTeoricas :=0.


self calcularOfertaTeoricaPorPrecio.
self calcularDemandaTeoricaPorPrecio.

filas do: [:fila |
	
	(unidadesTeoricas < fila calcularUnidadesTeoricas)	 ifTrue: [
													unidadesTeoricas:= fila calcularUnidadesTeoricas.
													precioMercado := fila getPrecio.]
	
	].


^precioMercado.! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 17:57'!
inicializar

filas := Dictionary new.

! !

Object subclass: #TradingTicket
	instanceVariableNames: 'ordenCompra ordenVenta fechaTransaccion precioMercado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!TradingTicket class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:15'!
crear: unaOrdenCompra ordenVenta: unaOrdenVenta precioMercado: unPrecio

| instancia | 


instancia := TradingTicket new.

instancia setPrecioMercado: unPrecio.
instancia setOrdenCompra: unaOrdenCompra.
instancia setOrdenVenta: unaOrdenVenta.
instancia setFechaTransaccion: Date today.

^instancia.
! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:11'!
getFechaTransaccion

	^fechaTransaccion.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:10'!
getOrdenCompra

	^ordenCompra.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:10'!
getOrdenVenta

	^ordenVenta.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:10'!
getPrecioMercado

	^precioMercado.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:12'!
setFechaTransaccion: unaFecha

fechaTransaccion := unaFecha.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:12'!
setOrdenCompra: unaOrdenCompra

ordenCompra := unaOrdenCompra.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:12'!
setOrdenVenta: unaOrdenVenta

ordenVenta = unaOrdenVenta.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:13'!
setPrecioMercado: unPrecio

precioMercado := unPrecio.! !

TestCase subclass: #PEMTest
	instanceVariableNames: ''
	classVariableNames: 'emisores ordenesDeCompra ordenesDeVenta'
	poolDictionaries: ''
	category: 'TyH-TP-Final-Test'!

!PEMTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/8/2012 17:36'!
iniciarSetDePruebas 


"Instanciamos las colecciones"


	emisores := OrderedCollection  new.
	ordenesDeCompra := OrderedCollection new.
	ordenesDeVenta := OrderedCollection new.
	

	self iniciarSetDePruebasEmisores.
	self iniciarSetDePruebasOrdenesCompra.
	self iniciarSetDePruebasOrdenesVenta.! !

!PEMTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/8/2012 17:45'!
iniciarSetDePruebasEmisores

| emisor |

emisor := Emisor crear: '30486645' nombre: 'Gabriel' apellido: 'Batistuta' cuit: '20-30486645-5' direccion: 'Por ahi 144'.

emisores add: emisor.! !

!PEMTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/8/2012 17:59'!
iniciarSetDePruebasOrdenesCompra

ordenesDeCompra add:
(OrdenCompra 
crear:'01/01/2000'
cantidad:1
precio:25
recibirEn:'OC1'
enviarComo: 'OC1').

ordenesDeCompra add:
(OrdenCompra 
crear:'02/02/2000'
cantidad:2
precio:60
recibirEn:'OC2'
enviarComo: 'OC2').

ordenesDeCompra add:
(OrdenCompra 
crear:'03/03/2000'
cantidad:2
precio:50
recibirEn:'OC3'
enviarComo: 'OC3').

ordenesDeCompra add:
(OrdenCompra 
crear:'04/04/2000'
cantidad:3
precio:90
recibirEn:'OC4'
enviarComo: 'OC4').

ordenesDeCompra add:
(OrdenCompra 
crear:'05/05/2000'
cantidad:4
precio:160
recibirEn:'OC5'
enviarComo: 'OC5').

ordenesDeCompra add:
(OrdenCompra 
crear:'06/06/2000'
cantidad:10
precio:200
recibirEn:'OC6'
enviarComo: 'OC6').
! !

!PEMTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/8/2012 18:00'!
iniciarSetDePruebasOrdenesVenta

ordenesDeVenta add:
(OrdenVenta
crear:'01/01/2000'
cantidad:2
precio:50
disponibleEnFecha:'02/02/2000'
pagoEn: 'OV1').

ordenesDeVenta add:
(OrdenVenta
crear:'02/02/2000'
cantidad:1
precio:25
disponibleEnFecha:'02/02/2000'
pagoEn: 'OV2').

ordenesDeVenta add:
(OrdenVenta
crear:'03/03/2000'
cantidad:3
precio:75
disponibleEnFecha:'02/02/2000'
pagoEn: 'OV3').

ordenesDeVenta add:
(OrdenVenta
crear:'04/04/2000'
cantidad:3
precio:180
disponibleEnFecha:'02/02/2000'
pagoEn: 'OV4').

ordenesDeVenta add:
(OrdenVenta
crear:'05/05/2000'
cantidad:1
precio:60
disponibleEnFecha:'02/02/2000'
pagoEn: 'OV5').

ordenesDeVenta add:
(OrdenVenta
crear:'06/06/2000'
cantidad:2
precio:80
disponibleEnFecha:'02/02/2000'
pagoEn: 'OV6').


ordenesDeVenta add:
(OrdenVenta
crear:'07/07/2000'
cantidad:2
precio:60
disponibleEnFecha:'02/02/2000'
pagoEn: 'OV7').! !

!PEMTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:55'!
testDepuracionOrdenes

	| pem |
	
	"se inicializan los datos del set de pruebas".
	self iniciarSetDePruebas.
	
	pem := PEM crear.
	
	"se agregan las ordenes al pem" .
	
	
	ordenesDeCompra do: [:unaOrdenCompra | pem addOrder: (Order ask: (unaOrdenCompra getCantidadUnidades)  price: (unaOrdenCompra getPrecio) date:(unaOrdenCompra getFechaIngreso))]. 
	ordenesDeVenta  do: [:unaOrdenVenta | pem addOrder: (Order bid: (unaOrdenVenta getCantidadUnidades)  price: (unaOrdenVenta getPrecio) date:(unaOrdenVenta getFechaIngreso))]. 
	
	
	"Ejecuta el proceso de trading"
	pem ejecutarTrading.
	
	"se valida el objetivo de la prueba".
	self assert: (pem getCantidadOrdenesRegistradas) = 9.! !

!PEMTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/8/2012 17:41'!
testEmisores

	| pem |
	
	self iniciarSetDePruebas.
	
	pem := PEM crear.
	
	emisores do: [ :unEmisor | 
					pem agregarEmisor: unEmisor.
					]. 
				
	
	self assert: (pem getCantidadEmisores) = emisores size.		
		
	! !

!PEMTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 19:16'!
testPrecioMercado

	| pem |
	
	self iniciarSetDePruebas.
	
	pem := PEM crear.
	
	ordenesDeCompra do: [:unaOrdenCompra | pem addOrder: (Order ask: (unaOrdenCompra getCantidadUnidades)  price: (unaOrdenCompra getPrecio) date:(unaOrdenCompra getFechaIngreso))].
	ordenesDeVenta do: [:unaOrdenVenta | pem addOrder: (Order bid: (unaOrdenVenta getCantidadUnidades)  price: (unaOrdenVenta getPrecio) date:(unaOrdenVenta getFechaIngreso))].
	
	self assert: (pem marketPrice) = 30.
	! !

!PEMTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:24'!
testRecepcionOrdenes

	| pem | 

	"se inician los datos del set de pruebas" 
	self iniciarSetDePruebas.
	
	pem := PEM crear.
	
	ordenesDeCompra do: [:unaOrdenCompra | pem addOrder: (Order bid: (unaOrdenCompra getCantidadUnidades)  price: (unaOrdenCompra getPrecio) date:(unaOrdenCompra getFechaIngreso))].
	ordenesDeVenta do: [:unaOrdenVenta | pem addOrder: (Order bid: (unaOrdenVenta getCantidadUnidades)  price: (unaOrdenVenta getPrecio) date:(unaOrdenVenta getFechaIngreso))].
	
	
	self assert: ((pem getCantidadOrdenesRegistradas) =  	((ordenesDeCompra size) + (ordenesDeVenta size))).! !
